import type { LazyLoadOptions } from "./ConfigCatClientOptions";
import type { IConfigFetcher } from "./ConfigFetcher";
import type { IConfigService, RefreshResult } from "./ConfigServiceBase";
import { ClientCacheState, ConfigServiceBase } from "./ConfigServiceBase";
import type { ProjectConfig } from "./ProjectConfig";
export declare class LazyLoadConfigService extends ConfigServiceBase<LazyLoadOptions> implements IConfigService {
    private readonly cacheTimeToLiveMs;
    readonly readyPromise: Promise<ClientCacheState>;
    constructor(configFetcher: IConfigFetcher, options: LazyLoadOptions);
    getConfig(): Promise<ProjectConfig>;
    refreshConfigAsync(): Promise<[RefreshResult, ProjectConfig]>;
    getCacheState(cachedConfig: ProjectConfig): ClientCacheState;
}
//# sourceMappingURL=LazyLoadConfigService.d.ts.map